//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 3
#property indicator_color1 LawnGreen
#property indicator_width1 4
#property indicator_color2 Red
#property indicator_width2 4
#property indicator_color3 White
#property indicator_width3 4

extern string EmaPeriods = "1,12;1,12;1,12";

double BlueBuffer[];
double YellowBuffer[];
double WhiteBuffer[];
double periods[][2];
int    size;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,BlueBuffer);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,YellowBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,WhiteBuffer);  SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
         
      if (StringSubstr(EmaPeriods,StringLen(EmaPeriods)-1,1) != ";")
                       EmaPeriods = StringConcatenate(EmaPeriods,";");
         int    s = 0;
         int    i = StringFind(EmaPeriods,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(EmaPeriods,s,i-s);
                     ArrayResize(periods,ArrayRange(periods,0)+1);
                                 int k = StringFind(current,",");
                                 periods[ArrayRange(periods,0)-1][0] = StrToDouble(StringSubstr(current,0,k));
                                 periods[ArrayRange(periods,0)-1][1] = StrToDouble(StringSubstr(current,k+1,0));
                                 s = i + 1;
                                     i = StringFind(EmaPeriods,";",s);
            }
         size = ArrayRange(periods,0);
   
      //
      //
      //
      //
      //
   
   IndicatorShortName(size+" EMA crossovers");
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
  {
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      int count = 0;
      for (int k=0; k<size; k++)
      {
         double macd = iMACD(NULL,0,periods[k][0],periods[k][1],1,PRICE_CLOSE,MODE_MAIN,i);
         if (macd>0) count++;
         if (macd<0) count--;
      }         
      BlueBuffer[i]   = EMPTY_VALUE;
      YellowBuffer[i] = EMPTY_VALUE;
      WhiteBuffer[i]  = EMPTY_VALUE;
      if (count== size) { BlueBuffer[i]   = 100; continue; }
      if (count==-size) { YellowBuffer[i] = 100; continue; }
                           WhiteBuffer[i] = 100; 
   }
   return(0);
}